-- test main module for Unlimited numbers
with 
   Unbounded_Rational, 
   Unlimited.Dynamic,
   Text_Io,
   System,
   Ada.Numerics.Discrete_Random,
   Calendar;
procedure test is 
   use Unbounded_Rational, Calendar, Unlimited, 
     Unlimited.Dynamic;

   Nil : Unbounded_Number renames Unlimited.Dynamic.Nil;
   One : Unbounded_Number renames Unlimited.Dynamic.One;

   package Int_Random is new Ada.Numerics.Discrete_Random(Int); 
   package Int_Io is new Text_IO.Integer_IO(Integer); use Int_IO;
   Gen : Int_Random.Generator;
   function Ri return Int is
   begin
      return Int_Random.Random(Gen);
   end;
   function Ru(Ai : Int) return Unbounded_Number is
      Result : Unbounded_Number := One;
   begin
      for I in 0..abs(Ai) loop
         Result := Result*Ri;
      end loop;
      return Shift(Result,Integer(Ai)*10);
   end;
   package Duration_IO is new Text_IO.Fixed_IO(Duration);
   DA,DM,Res,Res2,Remain :  Unbounded_Number;
   PrevTime : Time := Clock;
   K : constant := 2**4;
   R1,R2,Rs,Rm : TRational;
   F : Int := 22;
   Intt : Int;
   intg : integer;
   procedure Error(msg : String) is
      Error_Unlimited_Operation : Exception;
   begin
      Text_IO.Put_Line(msg);
      raise Error_Unlimited_Operation;
   end;
   
  begin
   Int_Random.Reset(Gen);
   for I in Positive'range loop
      DA := Ru(Ri rem f);
      Dm := Ru(Ri rem f);
      Text_IO.Put_Line(To_String(DA,16));
      if DA = DA + Unlimited.Dynamic.One then 
        Error("""=""");      
      end if;
      if DA/=DA then 
        Error("""/=""");      
      end if;
      if DA>DM and DA<DM then 
        Error("><");      
      end if;
      if DA>=DM and DA<=DM and DA/=DM then
        Error(">=<");      
      end if;
      if (-DA-DM)/= -(DM+DA) then
        Error("+-");      
      end if;    
      while dm=nil loop
        Dm := Ru(Ri rem f);
      end loop;
      Divide(DA,DM,Res,Remain);
      if Remain/=Nil 
            and (DA<Nil xor Remain<Nil) then 
         Error("-Rem");      
      end if;      
      if abs(Remain)>=abs(DM) then 
         Error("Remain");
      end if;
      if -Res*DM - Remain /= -DA then
         Error("*/");
      end if;
      DA := DA-Remain;
      Divide(DA,DM,Res2,Remain);
      if Res/=Res2 or Remain/=Nil then 
         Error("Rem0");
      end if;
      if Res2*DM  /= DA then
         Error("Back *");
      end if;
      loop
        Intt := Ri;
        exit when Intt/=0;
      end loop;
      Res := DM/Intt;
      Remain := DM rem Intt;
      if Res*Intt+Remain /= DM then
         Error("Int/");
      end if;
      Intg := Int'Pos(Intt);
      if Shift(Shift(Dm,intg),-intg)/=Dm then
         Error("Shift");
      end if;    
      DA := Ru(Abs(Ri rem f));
      DM := Ru(Abs(Ri rem f));
      if ((DA and (-One xor DM)) or ((-One xor DA) and DM)) /= (DA xor DM) then
        Error("Bitwise");
      end if;    
      if I rem K = 0 then
         Duration_Io.Put(Clock-PrevTime);Text_IO.New_Line;
         PrevTime := Clock;
         R1 := Ru(Ri rem F)/Ru(Ri rem F);
         R2 := Ru(Ri rem F)/Ru(Ri rem F);
         Rs := R1+R2;
         Rm := R1*R2;
         if Rs-R1/=R2 then
            Error("R+-");
         end if;
         if Rm/R1/=R2 then
            Error("R*/");
         end if;
      end if;
   end loop;
end test;
